#ifndef KASYNC_FILE_H_99
#define KASYNC_FILE_H_99
#include "kfeature.h"
#include "kselectable.h"
#include "kfile.h"
#ifdef LINUX
#include <linux/aio_abi.h>
#elif BSD_OS
#include <aio.h>
#endif
KBEGIN_DECLS
extern int kgl_aio_align_size;
void init_aio_align_size();
void *aio_alloc_buffer(size_t size);
void aio_free_buffer(void *buf);
kev_result result_async_file_event(KOPAQUE data, void *arg, int got);
struct kasync_file_s {
#ifdef LINUX_EPOLL
	struct iocb iocb;
	int offset_adjust;
	int length;
	KOPAQUE data;
	FILE_HANDLE fd;
	kselector *selector;
#else
	kselectable st;
#endif
	
#ifdef BSD_OS
	struct aiocb iocb;
#endif
	char *buf;
	void *arg;
	aio_callback cb;
};
void async_file_event(kasync_file *fp,char *buf,int got);
INLINE void kasync_file_close(kasync_file *fp)
{
#ifdef  LINUX_EPOLL
	kfclose(fp->fd);
#else
	kfclose((FILE_HANDLE)fp->st.fd);
#endif
}
INLINE kselector *kasync_file_get_selector(kasync_file *fp)
{
#ifdef LINUX_EPOLL
	return fp->selector;
#else
	return fp->st.selector;
#endif
}
INLINE void kasync_file_bind_opaque(kasync_file *fp, KOPAQUE data)
{
#ifdef LINUX_EPOLL
	fp->data = data;
#else
	fp->st.data = data;
#endif
}
INLINE KOPAQUE kasync_file_get_opaque(kasync_file *fp)
{
#ifdef LINUX_EPOLL
	return fp->data;
#else
	return fp->st.data;
#endif
}
KEND_DECLS
#endif
