#ifndef KASYNCFETCHOBJECT_H
#define KASYNCFETCHOBJECT_H
#include "KSocketBuffer.h"
#include "KUpstream.h"
#include "KHttpObject.h"
#include "kselector.h"
#include "KHttpResponseParser.h"
#include "KHttpParser.h"
enum Parse_Result
{
	Parse_Failed,
	Parse_Success,
	Parse_Continue
};
struct kgl_pop_header {
	Proto_t proto;
	uint16_t status_send : 1;
	uint16_t no_body:1;
	int keep_alive_time_out;
	time_t first_body_time;
};
/**
* 첽չ֧첽õչӸ̳
*/
class KAsyncFetchObject : public KFetchObject
{
public:
	KAsyncFetchObject()
	{
		client = NULL;
		badStage = BadStage_Connect;
		buffer = NULL;
		memset(&parser, 0, sizeof(parser));
		memset(&us_buffer, 0, sizeof(us_buffer));
		memset(&pop_header, 0, sizeof(pop_header));
	}
	void Close(KHttpRequest *rq)
	{
		KFetchObject::Close(rq);
		if (client) {
			assert(!client->IsLocked());
			if (TEST(rq->filter_flags,RF_UPSTREAM_NOKA) 
				|| !rq->ctx->upstream_connection_keep_alive
				|| !rq->ctx->upstream_expected_done) {
				pop_header.keep_alive_time_out = -1;
			}
			client->Gc(pop_header.keep_alive_time_out, pop_header.first_body_time);
			client = NULL;
		}		
		ResetBuffer();		
	}
	virtual ~KAsyncFetchObject()
	{
		assert(client==NULL);	
		if (client) {
			client->Gc(-1,0);
		}
		if (buffer) {
			delete buffer;
		}
		if (us_buffer.buf) {
			xfree(us_buffer.buf);
		}
	}
	//еɣڱʶӻ
	virtual void expectDone(KHttpRequest *rq)
	{
		rq->ctx->upstream_expected_done = 1;
	}
#ifdef ENABLE_REQUEST_QUEUE
	bool needQueue(KHttpRequest *rq)
	{
		return true;
	}
#endif
	kev_result Open(KHttpRequest *rq, kgl_push_gate *gate);
	kev_result Read(KHttpRequest *rq);
public:
	kev_result sendHead(KHttpRequest *rq);
	kev_result handleReadBody(KHttpRequest *rq,int got);
	kev_result handleReadHead(KHttpRequest *rq,int got);
	kev_result handleSendHead(KHttpRequest *rq,int got);
	kev_result handleHttp2ReadHead(KHttpRequest *rq,int got);
	kev_result handleSendPost(KHttpRequest *rq,int got);
	kev_result PostResult(KHttpRequest *rq,int got);
	//õpost壬͵upstream
	int getPostRBuffer(KHttpRequest *rq,LPWSABUF buf,int bc)
	{
		//°Ѿ̣֮ǰͰԤصݷ͵bufferˡ
		//assert(rq->pre_post_length==0);
		return buffer->getReadBuffer(buf,bc);
	}
	//õpostд壬clientpost
	char *GetPostBuffer(KHttpRequest *rq, int *len)
	{
		return buffer->getWriteBuffer(len);
	}
	//õbody,upstream
	char *getUpstreamBuffer(int *len)
	{
		return ks_get_write_buffer(&us_buffer, len);
	}
	KUpstream *GetUpstream()
	{
		return client;
	}
	kev_result connect_result(KHttpRequest *rq, bool half_connection);
	kev_result connectCallBack(KHttpRequest *rq,KUpstream *client,bool half_connection = true);
	kev_result handleUpstreamError(KHttpRequest *rq,int error,const char *msg,int last_got);
	kev_result handleConnectResult(KHttpRequest *rq,int got);
	kev_result shutdown(KHttpRequest *rq);
	KGL_RESULT PushHeader(KHttpRequest *rq,const char *attr, int attr_len, const char *val, int val_len, bool request_line);
	ks_buffer us_buffer;
	KSocketBuffer *buffer;
	KUpstream *client;
	BadStage badStage;
	friend class KHttp2;
protected:
	kev_result sendHeadSuccess(KHttpRequest *rq);
	kev_result readHeadSuccess(KHttpRequest *rq);
	void BuildChunkHeader();
	void PushStatus(KHttpRequest *rq, int status_code);
	kev_result PushHeaderFinished(KHttpRequest *rq);
	//ͷbufferС
	virtual void buildHead(KHttpRequest *rq) = 0;
	//head
	virtual kgl_parse_result ParseHeader(KHttpRequest *rq,char **data, int *len);
	virtual KGL_RESULT ParseBody(KHttpRequest *rq, char **data, int *len);
	//postݵbufferС
	virtual void buildPost(KHttpRequest *rq)
	{
	}
	//ǷҪbody,һ㳤Ҫ
	//content-lengthøú
	virtual bool checkContinueReadBody(KHttpRequest *rq)
	{
		return true;
	}
	khttp_parser parser;
	kgl_pop_header pop_header;
private:
	void ResetBuffer();
	kev_result InternalOpen(KHttpRequest *rq);
	kev_result ParseBody(KHttpRequest *rq);
	kev_result PushBodyResult(KHttpRequest *rq, KGL_RESULT result);
	void read_hup(KHttpRequest *rq);	
	kev_result continueReadBody(KHttpRequest *rq);
	kev_result readPost(KHttpRequest *rq);
	kev_result sendPost(KHttpRequest *rq);
	kev_result retryOpen(KHttpRequest *rq);
	kev_result startReadHead(KHttpRequest *rq);
	void InitUpstreamBuffer()
	{
		if (us_buffer.buf) {
			xfree(us_buffer.buf);
		}
		ks_buffer_init(&us_buffer, 8192);
	}
};
#endif
