#include "KCompressStream.h"
#include "KHttpRequest.h"
#include "KHttpObject.h"
#include "KGzip.h"
#ifdef ENABLE_BROTLI
#include "KBrotli.h"
#endif

KCompressStream *create_compress_stream(KHttpRequest *rq, KHttpObject *obj, int64_t content_len)
{
	if (content_len >= 0 && content_len < conf.min_compress_length) {
		//̫
		return NULL;
	}
	if (rq->ctx->connection_upgrade) {
		//͸ģʽѹ
		return NULL;
	}
	//objΪѾѹ߱˲ѹѹ
	if (obj->IsContentEncoding()) {
		return NULL;
	}
	//objж,ѹ
	if (obj->refs > 1) {
		return NULL;
	}
	//status_code206ʾǲʱҲѹ,200Ӧurl ranged
	//עûоϸ֤
	if (obj->data->status_code == STATUS_CONTENT_PARTIAL
		|| TEST(rq->raw_url.flags, KGL_URL_RANGED)) {
		return NULL;
	}
	if (TEST(obj->index.flags, FLAG_DEAD) && conf.only_compress_cache == 1) {
		return NULL;
	}
#ifdef ENABLE_BROTLI
	if (obj->need_compress && conf.br_level>0 && TEST(rq->raw_url.accept_encoding, KGL_ENCODING_BR)) {
		obj->AddContentEncoding(KGL_ENCODING_BR, kgl_expand_string("br"));
		return new KBrotliCompress();
	}
#endif
	//ͻ֧gzipѹʽ
	if (obj->need_compress && conf.gzip_level>0 && TEST(rq->raw_url.accept_encoding, KGL_ENCODING_GZIP)) {
		obj->AddContentEncoding(KGL_ENCODING_GZIP, kgl_expand_string("gzip"));
		return new KGzipCompress();
	}
	return NULL;
}