#ifndef KDSOASYNCFETCHOBJECT_H
#define KDSOASYNCFETCHOBJECT_H
#include "KFetchObject.h"
#include "KHttpResponseParser.h"
#include "KDsoRedirect.h"

class KDsoAsyncFetchObject : public KFetchObject
{
public:
	KDsoAsyncFetchObject(bool need_check)
	{
		memset(&ctx, 0, sizeof(ctx));
		this->need_check = need_check;
	}
	KDsoAsyncFetchObject(void *model_ctx,bool need_check)
	{
		memset(&ctx, 0, sizeof(ctx));
		ctx.module = model_ctx;
		this->need_check = need_check;
	}
	kgl_async_upstream *GetAsyncUpstream()
	{
		KDsoRedirect *dr = static_cast<KDsoRedirect *>(brd->rd);
		return (kgl_async_upstream *)dr->us;
	}
	bool NeedTempFile(bool upload, KHttpRequest *rq)
	{
		if (upload) {
			return rq->content_length == -1;
		}
		return false;
	}
#ifdef ENABLE_REQUEST_QUEUE
	bool needQueue(KHttpRequest *rq)
	{
		KFetchObject *next = rq->GetNextFetchObject(this);
		if (next) {
			return next->needQueue(rq);
		}
		return false;
	}
#endif
	~KDsoAsyncFetchObject();
	kev_result Check(KHttpRequest *rq);
	kev_result Open(KHttpRequest *rq, kgl_push_gate *gate);
	void Close(KHttpRequest *rq);
	kev_result Read(KHttpRequest *rq);
	kev_result PostResult(KHttpRequest *rq, int got);
	char *GetPostBuffer(KHttpRequest *rq, int *len);
	kgl_async_context ctx;
private:
	void init();
};
kgl_async_context * kgl_get_async_context(KCONN cn);
#endif

