#include "KDsoNextUpstream.h"
#include "KDsoAsyncFetchObject.h"
#include "http.h"
static kev_result next_check(KREQUEST rq, kgl_async_context *ctx)
{
	KDsoAsyncFetchObject *fo = (KDsoAsyncFetchObject *)ctx->cn;
	KFetchObject *next = ((KHttpRequest *)rq)->GetNextFetchObject(fo);
	return next->Check((KHttpRequest *)rq);
}
static kev_result next_open(KREQUEST rq, kgl_async_context *ctx)
{
	KDsoAsyncFetchObject *fo = (KDsoAsyncFetchObject *)ctx->cn;	
	if (fo->gate == NULL) {
		return send_error((KHttpRequest *)rq, 500, "fo not opened");
	}
	KFetchObject *next = ((KHttpRequest *)rq)->GetNextFetchObject(fo);
	return next->Open((KHttpRequest *)rq, &fo->ctx.ug);
}
static kev_result next_read(KREQUEST rq, kgl_async_context *ctx)
{
	KDsoAsyncFetchObject *fo = (KDsoAsyncFetchObject *)ctx->cn;
	if (fo->gate == NULL) {
		return send_error((KHttpRequest *)rq, 500, "fo not opened");
	}
	KFetchObject *next = ((KHttpRequest *)rq)->GetNextFetchObject(fo);
	return next->Read((KHttpRequest *)rq);
}
static void next_close(KREQUEST rq, kgl_async_context *ctx)
{
	KDsoAsyncFetchObject *fo = (KDsoAsyncFetchObject *)ctx->cn;
	KFetchObject *next = ((KHttpRequest *)rq)->GetNextFetchObject(fo);
	next->Close((KHttpRequest *)rq);
}

kgl_async_upstream next_upstream = {
	sizeof(kgl_async_upstream),
	0,
	"next_upstream",
	NULL,
	NULL,
	next_check,
	next_open,
	next_read,
	next_close
};
