/*
 * KFetchObject.h
 *
 *  Created on: 2010-4-19
 *      Author: keengo
 * Copyright (c) 2010, NanChang BangTeng Inc
 * All Rights Reserved.
 *
 * You may use the Software for free for non-commercial use
 * under the License Restrictions.
 *
 * You may modify the source code(if being provieded) or interface
 * of the Software under the License Restrictions.
 *
 * You may use the Software for commercial use after purchasing the
 * commercial license.Moreover, according to the license you purchased
 * you may get specified term, manner and content of technical
 * support from NanChang BangTeng Inc
 *
 * See COPYING file for detail.
 */

#ifndef KFETCHOBJECT_H_
#define KFETCHOBJECT_H_
#include <time.h>
#include "KBuffer.h"
#include "KPathRedirect.h"
#include "kselector.h"
#include "ksapi.h"

#define READ_SWITCH_FUNCTION	-3
#define READ_PROTOCOL_ERROR		-2
#define SEND_HEAD_FAILED		0
#define SEND_HEAD_SUCCESS		1
#define SEND_HEAD_PULL_MODEL	2
//#define SEND_HEAD_ASYNC_MODEL   3
#define SEND_HEAD_SYNC_MODEL    4
#define SEND_HEAD_ERROR         5
#ifdef ENABLE_REQUEST_QUEUE
class KRequestQueue;
#endif
class KHttpObject;
class KHttpRequest;
class KContext;
class KUpstream;
/**
Դ(̬ݣ̬ݣ⣬ݾԴԴ)
ԴĻ
*/
class KFetchObject {
public:
	KFetchObject()
	{
		brd = NULL;
		flags = 0;
		gate = NULL;
	}
	virtual ~KFetchObject();
	/*
	飬Open֮ǰ
	*/
	virtual kev_result Check(KHttpRequest *rq);
	/*
	 * Դ,
	 */
	virtual kev_result Open(KHttpRequest *rq, kgl_push_gate *gate);
	//ȡbody
	virtual kev_result Read(KHttpRequest *rq);
	/*
	 *Ƿͬ
	*/
	virtual bool isSync()
	{
		return false;
	}
	virtual KUpstream *GetUpstream()
	{
		return NULL;
	}
	//رԴ
	virtual void Close(KHttpRequest *rq);
	bool IsOpened()
	{
		return opened;
	}
	void bindRedirect(KRedirect *rd,uint8_t confirmFile)
	{
		kassert(this->brd == NULL);
		this->brd = new KBaseRedirect(rd, confirmFile);
	}
	void bindBaseRedirect(KBaseRedirect *brd)
	{
		kassert(this->brd==NULL);
		this->brd = brd;
		if (brd) {
			brd->addRef();
		}
	}
	KBaseRedirect *getBaseRedirect()
	{
		return brd;
	}
	//virtual KFetchObject *clone(KHttpRequest *rq);
	virtual bool NeedTempFile(bool upload, KHttpRequest *rq);
	bool IsChunkPost()
	{
		return chunk_post;
	}
	union {
		struct {
			uint32_t opened : 1;
			uint32_t chunk_post : 1;
			uint32_t filter : 1;
			uint32_t need_check : 1;
		};
		uint32_t flags;
	};
#ifdef ENABLE_REQUEST_QUEUE
	//ԴǷҪйܡڱݲøùܡ
	//ݺͶ̬򷵻true
	virtual bool needQueue(KHttpRequest *rq)
	{
		return false;
	}
#endif
	virtual bool IsLocked(KHttpRequest *rq);
	virtual void Shutdown(KHttpRequest *rq);
	virtual kev_result PostResult(KHttpRequest *rq, int got);
	virtual char *GetPostBuffer(KHttpRequest *rq, int *size);
	KGL_RESULT PushBody(KHttpRequest *rq, const char *buf, int len);
	kgl_list queue;
	kgl_push_gate *gate;
protected:
	KBaseRedirect *brd;	
	/*
	Ѿupstreamݣtrue,ȡfalse򲻼ʾѾݿԷrq
	*/
	kev_result pushHttpBody(KHttpRequest *rq,const char *buf,int len);
};
//ԴʾԴȷ
class KRefFetchObject : public KFetchObject
{
public:
	KRefFetchObject(KFetchObject *fo) : KFetchObject()
	{
		this->fo = fo;
	}
	~KRefFetchObject()
	{
		if (this->fo) {
			delete this->fo;
		}
	}
	kev_result Check(KHttpRequest *rq);
	kev_result Open(KHttpRequest *rq, kgl_push_gate *gate);
	KFetchObject *fo;
};
#endif /* KFETCHOBJECT_H_ */
