#ifndef KSIMULATEREQUEST_H
#define KSIMULATEREQUEST_H
#include "global.h"
#include "ksocket.h"
#include "KHttpHeaderManager.h"
#include "ksapi.h"
#include "kconnection.h"
#include "KHttpStream.h"
#include "KFileName.h"
#include "KSink.h"
#ifdef ENABLE_SIMULATE_HTTP
KHttpRequest *kgl_create_simulate_request(kgl_async_http *ctx);
void kgl_start_simulate_request(KHttpRequest *rq);
int asyncHttpRequest(kgl_async_http *ctx);
class KFileStream : public KWriteStream {
public:
	bool open(const char *str)
	{
		return fp.open(str, fileWrite);
	}
	int write(KHttpRequest *rq, const char *buf, int len)
	{
		return fp.write(buf, len);
	}
	StreamState write_end(KHttpRequest *rq) {
		if (last_modified > 0) {
			if (!kfutime(fp.getHandle(), last_modified)) {
				//printf("update modifi time=[%x] error\n", (unsigned)last_modified);
			}
		}
		fp.close();
		return STREAM_WRITE_SUCCESS;
	}
	time_t last_modified;
private:
	KFile fp;
};
class KSimulateSink : public KSink
{
public:
	KSimulateSink();
	~KSimulateSink();

	bool SetTransferChunked()
	{
		return false;
	}
	bool ResponseStatus(KHttpRequest *rq, uint16_t status_code)
	{
		this->status_code = status_code;
		return true;
	}
	bool ResponseHeader(const char *name, int name_len, const char *val, int val_len)
	{
		KHttpHeader *header = new_pool_http_header(c->pool, name, name_len, val, val_len);
		if (header) {
			header_manager.Append(header);
		}
		return true;
	}
	bool ResponseConnection(const char *val, int val_len)
	{
		return false;
	}
	//ͷ,-1ʾ
	int StartResponseBody(KHttpRequest *rq, int64_t body_size)
	{
		if (header) {
			header(async_http_arg, status_code, header_manager.header);
		}
		return 0;
	}
	bool IsLocked()
	{
		return false;
	}
	kev_result Write(void *arg, result_callback result, buffer_callback buffer)
	{
		if (write) {
			return write(async_http_arg, c->st.data, arg, result, buffer);
		}		
		WSABUF buf;
		int bc = buffer(c->st.data, arg, &buf, 1);
		if (bc != 1) {
			return result(c->st.data, arg, -1);
		}
		return result(c->st.data, arg, buf.iov_len);
	}
	kev_result Read(void *arg, result_callback result, buffer_callback buffer)
	{
		if (read) {
			return read(async_http_arg, c->st.data, arg, result, buffer);
		}
		return result(c->st.data, arg, -1);
	}
	bool ReadHup(void *arg, result_callback result)
	{
		return false;
	}
	void RemoveReadHup()
	{

	}
	int Read(char *buf, int len)
	{		
		return 0;
	}
	bool HasHeaderDataToSend()
	{
		return false;
	}
	int Write(LPWSABUF buf, int bc)
	{
		return -1;
	}
	sockaddr_i *GetAddr()
	{
		return &c->addr;
	}
	bool GetSelfAddr(sockaddr_i *addr)
	{
		kgl_memcpy(addr, &c->addr, sizeof(sockaddr_i));
		return true;
	}
	void EndRequest(KHttpRequest *rq);
	void AddSync()
	{

	}
	void RemoveSync()
	{

	}
	void Shutdown()
	{

	}
	kconnection *GetConnection()
	{
		return c;
	}
	void SetTimeOut(int tmo_count)
	{

	}
	int GetTimeOut()
	{
		return c->st.tmo;
	}
	void Flush()
	{

	}
	void SetWriteLimit(bool limit_flag)
	{

	}
	void SetReadLimit(bool limit_flag)
	{

	}
	http_header_hook header;

	async_http_io read;
	async_http_io write;
	async_http_close close;

	KHttpHeaderManager header_manager;
	char *host;
	uint16_t port;
	uint16_t status_code;
	int life_time;
	int exptected_done;
	void *async_http_arg;
	kconnection *c;	
protected:
	void SetReadDelay(bool delay_flag)
	{

	}
	void SetWriteDelay(bool delay_flag)
	{

	}

};
void async_download(const char *url, const char *file, result_callback cb, void *arg);
bool test_simulate_request();
#endif
#endif
