#include "KStaticFetchObject.h"
#include "http.h"
#include "KContentType.h"
#include "KVirtualHostManage.h"


kev_result resultStaticAsyncRead(kasync_file *fp, void *arg, char *buf, int got)
{
	KHttpRequest *rq = (KHttpRequest *)kasync_file_get_opaque(fp);
	KStaticFetchObject *fo = (KStaticFetchObject *)arg;// rq->fetchObj);
	return fo->handleAsyncReadBody(rq,buf,got);
}
#if 0
KTHREAD_FUNCTION simulateAsyncRead(void *param,int msec)
{
	KHttpRequest *rq = (KHttpRequest *)param;
	KStaticFetchObject *fo = static_cast<KStaticFetchObject *>(rq->fetchObj);
	fo->syncReadBody(rq);
	KTHREAD_RETURN;
}
#endif
kev_result KStaticFetchObject::Open(KHttpRequest *rq, kgl_push_gate *gate)
{
	KFetchObject::Open(rq, gate);
	return InternalOpen(rq);
}
kev_result KStaticFetchObject::InternalOpen(KHttpRequest *rq)
{
	kassert(!rq->file->isDirectory());
	KHttpObject *obj = rq->ctx->obj;
	SET(obj->index.flags,ANSW_LOCAL_SERVER);
	if (rq->ctx->lastModified > 0 && rq->ctx->lastModified == rq->file->getLastModified()) {
		if (rq->ctx->mt==modified_if_modified) {
			this->gate->f->push_status(this->gate, rq, STATUS_NOT_MODIFIED);
			return this->gate->f->push_header_finish(this->gate, rq);
		}
	} else if (rq->ctx->mt == modified_if_range_date||rq->ctx->mt == modified_if_range_etag) {
		CLR(rq->flags,RQ_HAVE_RANGE);
	}
	assert(rq->file);
	FILE_HANDLE fp;
	kfinit(fp);
#ifdef ENABLE_UNICODE_FILE
	const wchar_t *wfilename = rq->file->getNameW();
	if (wfilename) {
		fp = kfopen_w(wfilename,fileRead,KFILE_ASYNC);
	}
#else
	const char *filename = rq->file->getName();
	if (filename) {
		fp = kfopen(filename,fileRead,KFILE_ASYNC);
	}
#endif
	if (!kflike(fp)) {
		return this->gate->f->push_message(this->gate, rq, KGL_MSG_ERROR, STATUS_NOT_FOUND, "file not found");
	}
	//ʼ첽
	kasync_file *aio_file = (kasync_file *)xmemory_newz(sizeof(kasync_file));
	kgl_selector_module.aio_open(rq->sink->GetSelector(),aio_file, fp);
	kasync_file_bind_opaque(aio_file, rq);
	ad = new KAsyncData(aio_file, conf.io_buffer);

#ifdef ENABLE_TF_EXCHANGE
	if (rq->tf) {
		//̬ʱļ
		delete rq->tf;
		rq->tf = NULL;
	}
#endif
	//content-type
	char *content_type = find_content_type(rq, obj);
	if (content_type==NULL) {
		return this->gate->f->push_message(this->gate, rq, KGL_MSG_ERROR, STATUS_FORBIDEN,"cann't find such content-type");
	}
	bool may_compress = false;
	if (obj->need_compress) {
		if (TEST(rq->raw_url.accept_encoding, KGL_ENCODING_GZIP)) {
			may_compress = true;
#ifdef ENABLE_BROTLI
		} else if (TEST(rq->raw_url.accept_encoding, KGL_ENCODING_BR)) {
			may_compress = true;
#endif
		}
	}
	if (may_compress && rq->file->fileSize >= conf.min_compress_length) {
		//ѹ򲻻Ӧ206
		CLR(rq->flags, RQ_HAVE_RANGE);
	}
	//int status_code = STATUS_OK;
	if (TEST(rq->flags,RQ_HAVE_RANGE)) {
		//
		rq->ctx->content_range_length = rq->file->fileSize;
		INT64 content_length = rq->file->fileSize;
		if(!adjust_range(rq,rq->file->fileSize)){
			xfree(content_type);
			return this->gate->f->push_message(this->gate, rq, KGL_MSG_ERROR, 416,"range error");
		}
		if (ad) {
			ad->offset = rq->range_from;
		} else if (!kfseek(fp,rq->range_from,seekBegin)) {
			xfree(content_type);
			return this->gate->f->push_message(this->gate, rq, KGL_MSG_ERROR, 500,"cann't seek to right position");
		}
		
		KStringBuf b;
		char buf[INT2STRING_LEN];
		b.WSTR("bytes ");
		b << int2string(rq->range_from, buf) << "-" ;
		b << int2string(rq->range_to, buf) << "/" ;
		b << int2string(content_length, buf);
		//int len = b.getSize();
		//obj->insertHttpHeader2(xstrdup("Content-Range"),sizeof("Content-Range")-1,b.stealString(),len);			
		//obj->data->status_code = STATUS_CONTENT_PARTIAL;
		//SET(obj->index.flags,ANSW_HAS_CONTENT_RANGE);
		//status_code = STATUS_CONTENT_PARTIAL;
		this->gate->f->push_status(this->gate, rq, STATUS_CONTENT_PARTIAL);
		this->gate->f->push_unknow_header(this->gate, rq, kgl_expand_string("Content-Range"), b.getString(), b.getSize());
		//obj->index.content_length = rq->file->fileSize;
	} else {
		this->gate->f->push_status(this->gate, rq, STATUS_OK);
	}
	if (obj->never_compress) {
		this->gate->f->push_unknow_header(this->gate, rq, kgl_expand_string("Content-Encoding"), kgl_expand_string("identity"));
	}
	this->gate->f->push_header(this->gate, rq, kgl_header_content_length, (const char *)&rq->file->fileSize, 0);
	time_t last_modified = rq->file->getLastModified();
	this->gate->f->push_header(this->gate, rq, kgl_header_last_modified, (const char *)&last_modified, 0);
	this->gate->f->push_unknow_header(this->gate, rq, kgl_expand_string("Content-Type"), content_type, (hlen_t)strlen(content_type));
	xfree(content_type);
	//rq->buffer << "1234";
	//֪ͨhttpͷѾ
	return this->gate->f->push_header_finish(this->gate, rq);
}
kev_result KStaticFetchObject::Read(KHttpRequest *rq)
{
	assert(rq->file);	
	if (ad) {
		return asyncReadBody(rq);
	}
	return gate->f->push_body_finish(gate,rq,KGL_ESYSCALL);
}
#if 0
kev_result KStaticFetchObject::syncReadBody(KHttpRequest *rq)
{
	assert(rq->tr);
	char buf[8192];
	int len;
	do {
		len = (int) MIN(rq->file->fileSize,(INT64)sizeof(buf));
		if (len <= 0) {
			return gate->f->push_body_finish(gate, rq, KGL_OK);
		}	
		len = kfread(fp,buf, len);
		if(len<=0){
			return gate->f->push_body_finish(gate, rq, KGL_EREAD_FILE);
		}	
		rq->file->fileSize -= len;
	} while(!KEV_HANDLED(pushHttpBody(rq,buf,len)));

	return kev_ok;
}
#endif
//첽io
kev_result KStaticFetchObject::handleAsyncReadBody(KHttpRequest *rq,char *buf,int got)
{
	if (got<=0) {
		return gate->f->push_body_finish(gate, rq, KGL_EREAD_FILE);
	}
	rq->file->fileSize -= got;
	if (ad != NULL) {
		ad->offset += got;
	}
	kev_result ret = pushHttpBody(rq, buf, got);
	if (KEV_HANDLED(ret)) {
		return ret;
	}
	return asyncReadBody(rq);
}
//첽io
kev_result KStaticFetchObject::asyncReadBody(KHttpRequest *rq)
{
	int len = (int) MIN(rq->file->fileSize,(INT64)ad->buf_size);
	if (len <= 0) {
		return gate->f->push_body_finish(gate, rq, KGL_OK);
	}
	if (!kgl_selector_module.aio_read(rq->sink->GetSelector(), ad->aio_fp, ad->buf, ad->offset, len, resultStaticAsyncRead, this)) {
		return gate->f->push_body_finish(gate, rq, KGL_ESYSCALL);
	}
	return kev_ok;
}
