#ifndef KVARY_H_99
#define KVARY_H_99
#include <string.h>
#include "global.h"
#include "kmalloc.h"
#include "lib.h"
#include "ksapi.h"
#include "KStringBuf.h"

#define KGL_VARY_EXTEND_CHAR   '|'


class KUrl;
class KHttpRequest;
class KHttpObject;

class KVary
{
public:
	KVary()
	{
		memset(this, 0, sizeof(*this));
	}
	~KVary()
	{
		if (key) {
			xfree(key);
		}
		if (val) {
			xfree(val);
		}
	}
	KVary *Clone()
	{
		KVary *vary = new KVary;
		vary->key = strdup(key);
		vary->val = strdup(val);
		return vary;
	}
	char *key;
	char *val;
};
struct KUrlKey
{
	KUrl *url;
	KVary *vary;
};
char *get_obj_url_key(KHttpObject *obj, int *len);
void update_url_vary_key(KUrlKey *uk, const char *key);
bool register_vary_extend(kgl_vary *vary);
bool build_vary_extend(KHttpRequest *rq, KStringBuf *s, const char *name, const char *value);
bool response_vary_extend(KHttpRequest *rq, KStringBuf *s, const char *name, const char *value);
#endif

