/*
 * KVirtualProcess.cpp
 *
 *  Created on: 2010-10-24
 *      Author: keengo
 */
#include <vector>
#include <list>
#include "KVirtualHostProcess.h"
#include "KAsyncFetchObject.h"
#include "lang.h"
using namespace std;
//ʧܵĴ
void handleVProcessPower(VProcessPowerParam *vpp,std::list<KVirtualHostProcessQueue *> &queue,bool success,KTcpUpstream *socket,bool half_connect)
{
	if (vpp->rq) {
		//еһ󣬰״Ӹ
		if (socket) {
			socket->BindSelector(vpp->rq->sink->GetSelector());
		}
		KUpstream *us = socket;
		if (success){
			if (us==NULL) {
				half_connect = false;
				us = vpp->process->connect(vpp->rq,vpp->rd, half_connect);
			}
		} else {
			assert(socket==NULL);
			//socket cann't be NULL.but is socket is not NULL.we also can handle it.
			if (us) {
				us->Destroy();
				us = NULL;
			}
		}
		assert(vpp->rq && vpp->process && vpp->rd);
		vpp->fo->connectCallBack(vpp->rq, us,half_connect);
	} else {
		//ûеһ󣬰״ɾ
		if (socket) {
			socket->Destroy();
			socket = NULL;
		}
	}
	list<KVirtualHostProcessQueue *>::iterator it;
	for (it = queue.begin(); it!=queue.end(); it++) {
		KUpstream *us = NULL;
		if (success) {
			us = vpp->process->connect((*it)->rq, vpp->rd, half_connect);
		}
		(*it)->fo->connectCallBack((*it)->rq, us, half_connect);
		delete (*it);
	}
}
//̹߳
KTHREAD_FUNCTION VProcessPowerWorker(void *param)
{
	VProcessPowerParam *vpp = (VProcessPowerParam *)param;
	assert(vpp);
	KVirtualHostProcess *process = vpp->process;
	assert(process);
	bool success;
	KVirtualHost *vh = vpp->vh;
	if (vh==NULL && vpp->rq) {
		vh = vpp->rq->svh->vh;
	}
	KTcpUpstream *socket = process->poweron(vh, vpp->rd, success);

	if (socket) {
		//һӣĿǰȶ.
		socket->Destroy();
		socket = NULL;
	}
	std::list<KVirtualHostProcessQueue *> queue;
	process->lock.Lock();
	queue.swap(process->queue);
	if (success) {
		process->status = VProcess_Poweron;
	} else {
		process->status = VProcess_Poweroff;
	}
	process->lock.Unlock();
	handleVProcessPower(vpp,queue,success,socket,false);
	delete vpp;
	process->release();
	KTHREAD_RETURN;
}
void getProcessInfo(const USER_T &user,const std::string &name,KProcess *process,KPoolableSocketContainer *ps,std::stringstream &s)
{
	//time_t totalTime = time(NULL) - process->startTime;
	s << "<tr>";
	s << "<td>[<a href='/process_kill?name=" << name << "&user=" << user;
	s << "&pid=" << process->getProcessId() << "'>" << klang["kill"] << "</a>]</td>";
	s << "<td>" << user << "</td>";
	s << "<td >" << process->getProcessId() << "</td>";

	s << "<td>" << (ps->getRef() - 1) << "</td>";
	s << "<td>" << ps->getSize() << "</td>";
	s << "<td>" << (kgl_current_sec - process->getPowerOnTime()) << "</td>";
	s << "</tr>\n";

}
kev_result KVirtualHostProcess::handleRequest(KHttpRequest *rq,KExtendProgram *rd, KAsyncFetchObject *fo)
{
	bool isHalf;
	if (status == VProcess_Poweron) {
		KUpstream *socket = connect(rq, rd, isHalf);
		return fo->connectCallBack(rq,socket,isHalf);
	}
	lock.Lock();
	switch (status) {
	case VProcess_Poweroff:
	case VProcess_Close:
		{
			VProcessPowerParam *param = new VProcessPowerParam;
			addRef();
			param->vh = rq->svh->vh;
			param->rq = rq;
			param->process = this;
			param->rd = rd;
			param->fo = fo;
			status = VProcess_Inprogress;			
			if(!kthread_pool_start(VProcessPowerWorker, param)){
				std::list<KVirtualHostProcessQueue *> tq;
				tq.swap(this->queue);
				lock.Unlock();
				handleVProcessPower(param,tq,false,NULL,false);
				delete param;
				this->release();
				return kev_ok;
			}
			break;
		}
	case VProcess_Inprogress:
		{
			//rq->c->removeRequest(rq,true);
			KVirtualHostProcessQueue *qi = new KVirtualHostProcessQueue();
			qi->rq = rq;
			qi->fo = fo;
			queue.push_back(qi);
			break;
		}
	case VProcess_Poweron:
		{
			lock.Unlock();
			KUpstream *socket = connect(rq, rd, isHalf);
			return fo->connectCallBack(rq,socket,isHalf);
		}
	}
	lock.Unlock();
	return kev_ok;
}
