#include <stdio.h>
#include "kstring.h"
#include "ksapi.h"
#include "upstream.h"

static void * create_ctx()
{
	return NULL;
}
static void free_ctx(void *ctx)
{
	test_context *t = (test_context *)ctx;
	delete t;
}
static kev_result open(KREQUEST r,kgl_async_context *ctx)
{
	test_context *t = (test_context *)ctx->module;
	if (t->model == test_upstream) {
		ctx->gate->f->push_status(ctx->gate, r, 200);
		return ctx->gate->f->push_header_finish(ctx->gate, r);
	}
	if (t->model == test_upload_sleep_forward) {
		init_push_gate(ctx);
		return ctx->f->open_next(r, ctx->cn, &ctx->ug, NULL);
	}
	return ctx->f->open_next(r, ctx->cn,NULL,NULL);
}
static kev_result read(KREQUEST r, kgl_async_context *ctx)
{
	test_context *t = (test_context *)ctx->module;
	if (t->model == test_upstream) {
		ctx->gate->f->push_body(ctx->gate, r, kgl_expand_string("test_upstream_ok"));
		return ctx->gate->f->push_body_finish(ctx->gate, r, KGL_OK);
	}
	if (ctx->us) {
		return ctx->us->read(r, ctx);
	}
	return ctx->gate->f->push_message(ctx->gate, r,KGL_MSG_ERROR, 500, "no upstream");
}
static void close(KREQUEST r,kgl_async_context *ctx)
{
	test_context *t = (test_context *)ctx->module;
	assert(t);
	if (t->model == test_upstream) {
		return;
	}
	if (ctx->us) {
		ctx->us->close(r, ctx);
	}
	return;
}

static kgl_async_upstream async_upstream = {
	sizeof(kgl_async_upstream),0,
	"async_test",
	create_ctx,
	free_ctx,
	NULL,
	open,
	read,
	close,
	NULL,
	NULL
};
void register_global_async_upstream(kgl_dso_version *ver)
{
	KGL_REGISTER_ASYNC_UPSTREAM(ver, &async_upstream);
}
void register_async_upstream(KREQUEST r, kgl_access_context *ctx, test_context *model_ctx)
{
	ctx->f->support_function(r, ctx->cn, KF_REQ_UPSTREAM, &async_upstream, (void **)&model_ctx);
}
